#!/usr/local/bin/wish4.2

proc prob {path} {
    frame $path \
	    -borderwidth 5 \
	    -relief ridge
    checkbutton $path.det \
	    -text "Deterministic HMM" \
	    -variable det
    label $path.label3 -text "Batch size"
    entry $path.batchsize -width 5 -relief sunken \
	    -textvariable batchsize
    label $path.label4 -text "Lambda"
    entry $path.lambda -width 5 -relief sunken \
	    -textvariable lambda
    label $path.label5 -text "Look ahead"
    entry $path.lookahead -width 5 -relief sunken \
	    -textvariable lookahead
    pack $path.det
    pack $path.label3 $path.batchsize 
    pack $path.label4 $path.lambda
    pack $path.label5 $path.lookahead
    return $path
}

proc run_merlin {} {
    global theoryfile examplefile batchsize lambda lookahead det method
    if {$theoryfile == {}} {
    } elseif {$batchsize == {}} {
    } elseif {$lambda == {}} {
    } elseif {$lookahead == {}} {
    } elseif {$examplefile == {}} {
    } else {
	prolog init
	prolog theory('$theoryfile')
	prolog examples('$examplefile')
	prolog det($det)
	if {$method == "prob"} {
	    prolog batch($batchsize)
	    prolog factor($lambda)
	    prolog look($lookahead)
	    prolog run_merlin2
	} else {
	    prolog run_merlin1
	}
    }
}

proc disable {path} {
    pack forget $path
}

proc enable {path} {
    pack $path
}

#set theoryfile 'examples/regular_ab'
#set examplefile 'examples/a+b+a+_ex'
set batchsize 1
set lambda 0.25
set lookahead 1
set det 1

label .label1 -text "Theory file"
entry .theoryfile -width 25 -relief sunken \
	-textvariable theoryfile
#button .theoryfile \
#	-text "Theory file" \
#	-command {set theoryfile [tk_getOpenFile]}

label .label2 -text "Example file"
entry .examplefile -width 25 -relief sunken \
	-textvariable examplefile

button .run -text "Run MERLIN" \
	-command run_merlin

set method prob
radiobutton .maximum \
	-text "Learning from positive examples only" \
	-variable method \
	-value prob \
	-command "enable .prob"
radiobutton .minimum \
	-text "Learning from positive and negative examples" \
	-variable method \
	-value size \
	-command "disable .prob"

prob .prob
text .t \
	-font *-palatino-medium-r-normal--*-120-* \
	-width 80  \
	-height 40 \
	-relief sunken \
	-yscrollcommand ".scroll set"
scrollbar .scroll -command ".t yview"
button .h -text "HELP" \
	-command "prolog help_text"
button .b -text "Quit" -command exit
#button .b -text "Quit" -command "destroy ."

pack .t -side left
pack .scroll -side left -fill y
pack .label1 .theoryfile -side top
pack .label2 .examplefile -side top
pack .minimum
pack .maximum
pack .b .h .run -side bottom -padx 2m -pady 2m
pack .prob \
	-padx 4\
	-pady 4

bind .theoryfile <Return> "focus .examplefile"
bind .examplefile <Return> "focus .run"
